//May.5.2005 Tak.Sugawara
module bench;
	reg rstn;
	reg clk=0;
  reg 			uart_srx=0;
   wire 			uart_stx;
   wire 			jtag_tvref; // 1
   wire 			jtag_tgnd; // 0
   reg 			jtag_tck=0;
   reg 			jtag_tms=0;
   reg 			jtag_trst=0;
   reg 			jtag_tdi=0;
   wire 			jtag_tdo;

  
  
initial
begin
             rstn = 0;
	#1000;
   		rstn = 1;
end




always
begin
   #10 clk <= ~clk;//Virtual 50MHz Clock
end

 xsv_fpga_top   dut(
		     clk, rstn,
		     uart_stx, uart_srx,
  		     jtag_tvref, jtag_tgnd, jtag_tck, jtag_tms, jtag_trst, jtag_tdi, jtag_tdo
		     );

  

 
//uart read port
  wire [7:0] buffer_reg;
  wire int_req;
  reg sync_reset;

  localparam LF=8'h0a;	
	always @(posedge clk, negedge rstn) begin
		if (!rstn) sync_reset <=1'b1;
		else sync_reset<=1'b0;
	end
	
   uart_read   uart_read_port( .sync_reset(sync_reset), .clk(clk), .rxd(uart_stx),.buffer_reg(buffer_reg), .int_req(int_req));

	always @(posedge int_req) begin
		begin :local
		
			reg [7:0] local_mem [0:1000];
			integer i=0;
			
			if (i>=1000) $stop;//assert(0);

			if (buffer_reg==LF) begin :local2 //pop stack
				integer j;
				j=0;
				while( j < i) begin
					$write( "%c",local_mem[j]);
					j=j+1;
				end
				$write("     : time=%t\n",$time);
				i=0;//clear stack	
			end else begin//push stack
				
				local_mem[i]=buffer_reg;
				i=i+1;
			 end
		end
		
	end




endmodule